package org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

/**
 * @generated
 */
public class ConnectionSourceReorientCommand extends EditElementCommand {

	/**
	 * @generated
	 */
	private final int reorientDirection;

	/**
	 * @generated
	 */
	private final EObject referenceOwner;

	/**
	 * @generated
	 */
	private final EObject oldEnd;

	/**
	 * @generated
	 */
	private final EObject newEnd;

	/**
	 * @generated
	 */
	public ConnectionSourceReorientCommand(
			ReorientReferenceRelationshipRequest request) {
		super(request.getLabel(), null, request);
		reorientDirection = request.getDirection();
		referenceOwner = request.getReferenceOwner();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	 * @generated
	 */
	public boolean canExecute() {
		if (false == referenceOwner instanceof org.eclipse.gmf.examples.gonto.modelOntology.Connection) {
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return canReorientTarget();
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean canReorientSource() {
		if (!(oldEnd instanceof org.eclipse.gmf.examples.gonto.modelOntology.GraphicalObject && newEnd instanceof org.eclipse.gmf.examples.gonto.modelOntology.Connection)) {
			return false;
		}
		return org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.policies.ModelOntologyBaseItemSemanticEditPolicy
				.getLinkConstraints().canExistConnectionSource_4001(
						getNewSource(), getOldTarget());
	}

	/**
	 * @generated
	 */
	protected boolean canReorientTarget() {
		if (!(oldEnd instanceof org.eclipse.gmf.examples.gonto.modelOntology.GraphicalObject && newEnd instanceof org.eclipse.gmf.examples.gonto.modelOntology.GraphicalObject)) {
			return false;
		}
		return org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.policies.ModelOntologyBaseItemSemanticEditPolicy
				.getLinkConstraints().canExistConnectionSource_4001(
						getOldSource(), getNewTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor,
			IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException(
					"Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientSource() throws ExecutionException {
		getOldSource().setSource(null);
		getNewSource().setSource(getOldTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientTarget() throws ExecutionException {
		getOldSource().setSource(getNewTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected org.eclipse.gmf.examples.gonto.modelOntology.Connection getOldSource() {
		return (org.eclipse.gmf.examples.gonto.modelOntology.Connection) referenceOwner;
	}

	/**
	 * @generated
	 */
	protected org.eclipse.gmf.examples.gonto.modelOntology.Connection getNewSource() {
		return (org.eclipse.gmf.examples.gonto.modelOntology.Connection) newEnd;
	}

	/**
	 * @generated
	 */
	protected org.eclipse.gmf.examples.gonto.modelOntology.GraphicalObject getOldTarget() {
		return (org.eclipse.gmf.examples.gonto.modelOntology.GraphicalObject) oldEnd;
	}

	/**
	 * @generated
	 */
	protected org.eclipse.gmf.examples.gonto.modelOntology.GraphicalObject getNewTarget() {
		return (org.eclipse.gmf.examples.gonto.modelOntology.GraphicalObject) newEnd;
	}
}
