package org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

/**
 * @generated
 */
public class InversObjectPropertyObjectPropertyReorientCommand extends
		EditElementCommand {

	/**
	 * @generated
	 */
	private final int reorientDirection;

	/**
	 * @generated
	 */
	private final EObject referenceOwner;

	/**
	 * @generated
	 */
	private final EObject oldEnd;

	/**
	 * @generated
	 */
	private final EObject newEnd;

	/**
	 * @generated
	 */
	public InversObjectPropertyObjectPropertyReorientCommand(
			ReorientReferenceRelationshipRequest request) {
		super(request.getLabel(), null, request);
		reorientDirection = request.getDirection();
		referenceOwner = request.getReferenceOwner();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	 * @generated
	 */
	public boolean canExecute() {
		if (false == referenceOwner instanceof org.eclipse.gmf.examples.gonto.modelOntology.InversObjectProperty) {
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return canReorientTarget();
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean canReorientSource() {
		if (!(oldEnd instanceof org.eclipse.gmf.examples.gonto.modelOntology.ObjectProperty && newEnd instanceof org.eclipse.gmf.examples.gonto.modelOntology.InversObjectProperty)) {
			return false;
		}
		return org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.policies.ModelOntologyBaseItemSemanticEditPolicy
				.getLinkConstraints()
				.canExistInversObjectPropertyObjectProperty_4003(
						getNewSource(), getOldTarget());
	}

	/**
	 * @generated
	 */
	protected boolean canReorientTarget() {
		if (!(oldEnd instanceof org.eclipse.gmf.examples.gonto.modelOntology.ObjectProperty && newEnd instanceof org.eclipse.gmf.examples.gonto.modelOntology.ObjectProperty)) {
			return false;
		}
		return org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.policies.ModelOntologyBaseItemSemanticEditPolicy
				.getLinkConstraints()
				.canExistInversObjectPropertyObjectProperty_4003(
						getOldSource(), getNewTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor,
			IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException(
					"Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientSource() throws ExecutionException {
		getOldSource().setObjectProperty(null);
		getNewSource().setObjectProperty(getOldTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientTarget() throws ExecutionException {
		getOldSource().setObjectProperty(getNewTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected org.eclipse.gmf.examples.gonto.modelOntology.InversObjectProperty getOldSource() {
		return (org.eclipse.gmf.examples.gonto.modelOntology.InversObjectProperty) referenceOwner;
	}

	/**
	 * @generated
	 */
	protected org.eclipse.gmf.examples.gonto.modelOntology.InversObjectProperty getNewSource() {
		return (org.eclipse.gmf.examples.gonto.modelOntology.InversObjectProperty) newEnd;
	}

	/**
	 * @generated
	 */
	protected org.eclipse.gmf.examples.gonto.modelOntology.ObjectProperty getOldTarget() {
		return (org.eclipse.gmf.examples.gonto.modelOntology.ObjectProperty) oldEnd;
	}

	/**
	 * @generated
	 */
	protected org.eclipse.gmf.examples.gonto.modelOntology.ObjectProperty getNewTarget() {
		return (org.eclipse.gmf.examples.gonto.modelOntology.ObjectProperty) newEnd;
	}
}
