package org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.LinkedList;

import org.eclipse.core.resources.IFile;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.edit.domain.AdapterFactoryEditingDomain;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.emf.workspace.util.WorkspaceSynchronizer;
import org.eclipse.gmf.runtime.emf.core.GMFEditingDomainFactory;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonContentProvider;

/**
 * @generated
 */
public class ModelOntologyNavigatorContentProvider implements
		ICommonContentProvider {

	/**
	 * @generated
	 */
	private static final Object[] EMPTY_ARRAY = new Object[0];

	/**
	 * @generated
	 */
	private Viewer myViewer;

	/**
	 * @generated
	 */
	private AdapterFactoryEditingDomain myEditingDomain;

	/**
	 * @generated
	 */
	private WorkspaceSynchronizer myWorkspaceSynchronizer;

	/**
	 * @generated
	 */
	private Runnable myViewerRefreshRunnable;

	/**
	 * @generated
	 */
	@SuppressWarnings({ "unchecked", "serial", "rawtypes" })
	public ModelOntologyNavigatorContentProvider() {
		TransactionalEditingDomain editingDomain = GMFEditingDomainFactory.INSTANCE
				.createEditingDomain();
		myEditingDomain = (AdapterFactoryEditingDomain) editingDomain;
		myEditingDomain.setResourceToReadOnlyMap(new HashMap() {
			public Object get(Object key) {
				if (!containsKey(key)) {
					put(key, Boolean.TRUE);
				}
				return super.get(key);
			}
		});
		myViewerRefreshRunnable = new Runnable() {
			public void run() {
				if (myViewer != null) {
					myViewer.refresh();
				}
			}
		};
		myWorkspaceSynchronizer = new WorkspaceSynchronizer(editingDomain,
				new WorkspaceSynchronizer.Delegate() {
					public void dispose() {
					}

					public boolean handleResourceChanged(final Resource resource) {
						unloadAllResources();
						asyncRefresh();
						return true;
					}

					public boolean handleResourceDeleted(Resource resource) {
						unloadAllResources();
						asyncRefresh();
						return true;
					}

					public boolean handleResourceMoved(Resource resource,
							final URI newURI) {
						unloadAllResources();
						asyncRefresh();
						return true;
					}
				});
	}

	/**
	 * @generated
	 */
	public void dispose() {
		myWorkspaceSynchronizer.dispose();
		myWorkspaceSynchronizer = null;
		myViewerRefreshRunnable = null;
		myViewer = null;
		unloadAllResources();
		((TransactionalEditingDomain) myEditingDomain).dispose();
		myEditingDomain = null;
	}

	/**
	 * @generated
	 */
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
		myViewer = viewer;
	}

	/**
	 * @generated
	 */
	void unloadAllResources() {
		for (Resource nextResource : myEditingDomain.getResourceSet()
				.getResources()) {
			nextResource.unload();
		}
	}

	/**
	 * @generated
	 */
	void asyncRefresh() {
		if (myViewer != null && !myViewer.getControl().isDisposed()) {
			myViewer.getControl().getDisplay()
					.asyncExec(myViewerRefreshRunnable);
		}
	}

	/**
	 * @generated
	 */
	public Object[] getElements(Object inputElement) {
		return getChildren(inputElement);
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public Object[] getChildren(Object parentElement) {
		if (parentElement instanceof IFile) {
			IFile file = (IFile) parentElement;
			URI fileURI = URI.createPlatformResourceURI(file.getFullPath()
					.toString(), true);
			Resource resource = myEditingDomain.getResourceSet().getResource(
					fileURI, true);
			ArrayList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorItem> result = new ArrayList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorItem>();
			ArrayList<View> topViews = new ArrayList<View>(resource
					.getContents().size());
			for (EObject o : resource.getContents()) {
				if (o instanceof View) {
					topViews.add((View) o);
				}
			}
			result.addAll(createNavigatorItems(
					selectViewsByType(
							topViews,
							org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.OntologyEditPart.MODEL_ID),
					file, false));
			return result.toArray();
		}

		if (parentElement instanceof org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup) {
			org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup group = (org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup) parentElement;
			return group.getChildren();
		}

		if (parentElement instanceof org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorItem) {
			org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorItem navigatorItem = (org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorItem) parentElement;
			if (navigatorItem.isLeaf() || !isOwnView(navigatorItem.getView())) {
				return EMPTY_ARRAY;
			}
			return getViewChildren(navigatorItem.getView(), parentElement);
		}

		return EMPTY_ARRAY;
	}

	/**
	 * @generated
	 */
	private Object[] getViewChildren(View view, Object parentElement) {
		switch (org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
				.getVisualID(view)) {

		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionSourceEditPart.VISUAL_ID: {
			LinkedList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem> result = new LinkedList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup target = new org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup(
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.Messages.NavigatorGroupName_ConnectionSource_4001_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup source = new org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup(
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.Messages.NavigatorGroupName_ConnectionSource_4001_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.AnnonymousIndividualEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ClassEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ObjectPropertyEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.AnnotationEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.NamedIndividualEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.InversObjectPropertyEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionTargetEditPart.VISUAL_ID: {
			LinkedList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem> result = new LinkedList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup target = new org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup(
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.Messages.NavigatorGroupName_ConnectionTarget_4002_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup source = new org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup(
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.Messages.NavigatorGroupName_ConnectionTarget_4002_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.AnnonymousIndividualEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ClassEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ObjectPropertyEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.AnnotationEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.NamedIndividualEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.InversObjectPropertyEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ObjectPropertyEditPart.VISUAL_ID: {
			LinkedList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem> result = new LinkedList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem>();
			Node sv = (Node) view;
			org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup incominglinks = new org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup(
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.Messages.NavigatorGroupName_ObjectProperty_2004_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionSourceEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionTargetEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.InversObjectPropertyObjectPropertyEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.InversObjectPropertyEditPart.VISUAL_ID: {
			LinkedList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem> result = new LinkedList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem>();
			Node sv = (Node) view;
			org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup incominglinks = new org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup(
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.Messages.NavigatorGroupName_InversObjectProperty_2007_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup outgoinglinks = new org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup(
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.Messages.NavigatorGroupName_InversObjectProperty_2007_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionSourceEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionTargetEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.InversObjectPropertyObjectPropertyEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.NamedIndividualEditPart.VISUAL_ID: {
			LinkedList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem> result = new LinkedList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem>();
			Node sv = (Node) view;
			org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup incominglinks = new org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup(
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.Messages.NavigatorGroupName_NamedIndividual_2006_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionSourceEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionTargetEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionEditPart.VISUAL_ID: {
			LinkedList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem> result = new LinkedList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem>();
			Node sv = (Node) view;
			org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup incominglinks = new org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup(
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.Messages.NavigatorGroupName_Connection_2003_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup outgoinglinks = new org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup(
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.Messages.NavigatorGroupName_Connection_2003_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionSourceEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionSourceEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionTargetEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionTargetEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.AnnonymousIndividualEditPart.VISUAL_ID: {
			LinkedList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem> result = new LinkedList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem>();
			Node sv = (Node) view;
			org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup incominglinks = new org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup(
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.Messages.NavigatorGroupName_AnnonymousIndividual_2001_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionSourceEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionTargetEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ClassEditPart.VISUAL_ID: {
			LinkedList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem> result = new LinkedList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem>();
			Node sv = (Node) view;
			org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup incominglinks = new org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup(
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.Messages.NavigatorGroupName_Class_2002_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionSourceEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionTargetEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.InversObjectPropertyObjectPropertyEditPart.VISUAL_ID: {
			LinkedList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem> result = new LinkedList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup target = new org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup(
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.Messages.NavigatorGroupName_InversObjectPropertyObjectProperty_4003_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup source = new org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup(
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.Messages.NavigatorGroupName_InversObjectPropertyObjectProperty_4003_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ObjectPropertyEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.InversObjectPropertyEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.AnnotationEditPart.VISUAL_ID: {
			LinkedList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem> result = new LinkedList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem>();
			Node sv = (Node) view;
			org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup incominglinks = new org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup(
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.Messages.NavigatorGroupName_Annotation_2005_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionSourceEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionTargetEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.OntologyEditPart.VISUAL_ID: {
			LinkedList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem> result = new LinkedList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem>();
			Diagram sv = (Diagram) view;
			org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup links = new org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorGroup(
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.Messages.NavigatorGroupName_Ontology_1000_links,
					"icons/linksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.AnnonymousIndividualEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ClassEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ObjectPropertyEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.AnnotationEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.NamedIndividualEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.InversObjectPropertyEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionSourceEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionTargetEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
							.getType(org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.InversObjectPropertyObjectPropertyEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			if (!links.isEmpty()) {
				result.add(links);
			}
			return result.toArray();
		}
		}
		return EMPTY_ARRAY;
	}

	/**
	 * @generated
	 */
	private Collection<View> getLinksSourceByType(Collection<Edge> edges,
			String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (Edge nextEdge : edges) {
			View nextEdgeSource = nextEdge.getSource();
			if (type.equals(nextEdgeSource.getType())
					&& isOwnView(nextEdgeSource)) {
				result.add(nextEdgeSource);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getLinksTargetByType(Collection<Edge> edges,
			String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (Edge nextEdge : edges) {
			View nextEdgeTarget = nextEdge.getTarget();
			if (type.equals(nextEdgeTarget.getType())
					&& isOwnView(nextEdgeTarget)) {
				result.add(nextEdgeTarget);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getOutgoingLinksByType(
			Collection<? extends View> nodes, String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (View nextNode : nodes) {
			result.addAll(selectViewsByType(nextNode.getSourceEdges(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getIncomingLinksByType(
			Collection<? extends View> nodes, String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (View nextNode : nodes) {
			result.addAll(selectViewsByType(nextNode.getTargetEdges(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getChildrenByType(
			Collection<? extends View> nodes, String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (View nextNode : nodes) {
			result.addAll(selectViewsByType(nextNode.getChildren(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getDiagramLinksByType(
			Collection<Diagram> diagrams, String type) {
		ArrayList<View> result = new ArrayList<View>();
		for (Diagram nextDiagram : diagrams) {
			result.addAll(selectViewsByType(nextDiagram.getEdges(), type));
		}
		return result;
	}

	// TODO refactor as static method
	/**
	 * @generated
	 */
	private Collection<View> selectViewsByType(Collection<View> views,
			String type) {
		ArrayList<View> result = new ArrayList<View>();
		for (View nextView : views) {
			if (type.equals(nextView.getType()) && isOwnView(nextView)) {
				result.add(nextView);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.OntologyEditPart.MODEL_ID
				.equals(org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
						.getModelID(view));
	}

	/**
	 * @generated
	 */
	private Collection<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorItem> createNavigatorItems(
			Collection<View> views, Object parent, boolean isLeafs) {
		ArrayList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorItem> result = new ArrayList<org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorItem>(
				views.size());
		for (View nextView : views) {
			result.add(new org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyNavigatorItem(
					nextView, parent, isLeafs));
		}
		return result;
	}

	/**
	 * @generated
	 */
	public Object getParent(Object element) {
		if (element instanceof org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem) {
			org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem abstractNavigatorItem = (org.eclipse.gmf.examples.gonto.modelOntology.diagram.navigator.ModelOntologyAbstractNavigatorItem) element;
			return abstractNavigatorItem.getParent();
		}
		return null;
	}

	/**
	 * @generated
	 */
	public boolean hasChildren(Object element) {
		return element instanceof IFile || getChildren(element).length > 0;
	}

}
