package org.eclipse.gmf.examples.gonto.modelOntology.diagram.part;

import java.lang.reflect.InvocationTargetException;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.jface.dialogs.ErrorDialog;
import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.ui.INewWizard;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.actions.WorkspaceModifyOperation;

/**
 * @generated
 */
public class ModelOntologyCreationWizard extends Wizard implements INewWizard {

	/**
	 * @generated
	 */
	private IWorkbench workbench;

	/**
	 * @generated
	 */
	protected IStructuredSelection selection;

	/**
	 * @generated
	 */
	protected org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyCreationWizardPage diagramModelFilePage;

	/**
	 * @generated
	 */
	protected org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyCreationWizardPage domainModelFilePage;

	/**
	 * @generated
	 */
	protected Resource diagram;

	/**
	 * @generated
	 */
	private boolean openNewlyCreatedDiagramEditor = true;

	/**
	 * @generated
	 */
	public IWorkbench getWorkbench() {
		return workbench;
	}

	/**
	 * @generated
	 */
	public IStructuredSelection getSelection() {
		return selection;
	}

	/**
	 * @generated
	 */
	public final Resource getDiagram() {
		return diagram;
	}

	/**
	 * @generated
	 */
	public final boolean isOpenNewlyCreatedDiagramEditor() {
		return openNewlyCreatedDiagramEditor;
	}

	/**
	 * @generated
	 */
	public void setOpenNewlyCreatedDiagramEditor(
			boolean openNewlyCreatedDiagramEditor) {
		this.openNewlyCreatedDiagramEditor = openNewlyCreatedDiagramEditor;
	}

	/**
	 * @generated
	 */
	public void init(IWorkbench workbench, IStructuredSelection selection) {
		this.workbench = workbench;
		this.selection = selection;
		setWindowTitle(org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.Messages.ModelOntologyCreationWizardTitle);
		setDefaultPageImageDescriptor(org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyDiagramEditorPlugin
				.getBundledImageDescriptor("icons/wizban/NewModelOntologyWizard.gif")); //$NON-NLS-1$
		setNeedsProgressMonitor(true);
	}

	/**
	 * @generated
	 */
	public void addPages() {
		diagramModelFilePage = new org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyCreationWizardPage(
				"DiagramModelFile", getSelection(), "modelontology_diagram"); //$NON-NLS-1$ //$NON-NLS-2$
		diagramModelFilePage
				.setTitle(org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.Messages.ModelOntologyCreationWizard_DiagramModelFilePageTitle);
		diagramModelFilePage
				.setDescription(org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.Messages.ModelOntologyCreationWizard_DiagramModelFilePageDescription);
		addPage(diagramModelFilePage);

		domainModelFilePage = new org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyCreationWizardPage(
				"DomainModelFile", getSelection(), "modelontology") { //$NON-NLS-1$ //$NON-NLS-2$

			public void setVisible(boolean visible) {
				if (visible) {
					String fileName = diagramModelFilePage.getFileName();
					fileName = fileName.substring(0, fileName.length()
							- ".modelontology_diagram".length()); //$NON-NLS-1$
					setFileName(org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyDiagramEditorUtil
							.getUniqueFileName(getContainerFullPath(),
									fileName, "modelontology")); //$NON-NLS-1$
				}
				super.setVisible(visible);
			}
		};
		domainModelFilePage
				.setTitle(org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.Messages.ModelOntologyCreationWizard_DomainModelFilePageTitle);
		domainModelFilePage
				.setDescription(org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.Messages.ModelOntologyCreationWizard_DomainModelFilePageDescription);
		addPage(domainModelFilePage);
	}

	/**
	 * @generated
	 */
	public boolean performFinish() {
		IRunnableWithProgress op = new WorkspaceModifyOperation(null) {

			protected void execute(IProgressMonitor monitor)
					throws CoreException, InterruptedException {
				diagram = org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyDiagramEditorUtil
						.createDiagram(diagramModelFilePage.getURI(),
								domainModelFilePage.getURI(), monitor);
				if (isOpenNewlyCreatedDiagramEditor() && diagram != null) {
					try {
						org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyDiagramEditorUtil
								.openDiagram(diagram);
					} catch (PartInitException e) {
						ErrorDialog
								.openError(
										getContainer().getShell(),
										org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.Messages.ModelOntologyCreationWizardOpenEditorError,
										null, e.getStatus());
					}
				}
			}
		};
		try {
			getContainer().run(false, true, op);
		} catch (InterruptedException e) {
			return false;
		} catch (InvocationTargetException e) {
			if (e.getTargetException() instanceof CoreException) {
				ErrorDialog
						.openError(
								getContainer().getShell(),
								org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.Messages.ModelOntologyCreationWizardCreationError,
								null, ((CoreException) e.getTargetException())
										.getStatus());
			} else {
				org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyDiagramEditorPlugin
						.getInstance()
						.logError(
								"Error creating diagram", e.getTargetException()); //$NON-NLS-1$
			}
			return false;
		}
		return diagram != null;
	}
}
