package org.eclipse.gmf.examples.gonto.modelOntology.diagram.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.structure.DiagramStructure;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class ModelOntologyVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = "cs.vsb.fei.gonto.diagram/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.OntologyEditPart.MODEL_ID
					.equals(view.getType())) {
				return org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.OntologyEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
				.getVisualID(view.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyDiagramEditorPlugin
						.getInstance().logError(
								"Unable to parse view type as a visualID number: "
										+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return Integer.toString(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (org.eclipse.gmf.examples.gonto.modelOntology.ModelOntologyPackage.eINSTANCE
				.getOntology().isSuperTypeOf(domainElement.eClass())
				&& isDiagram((org.eclipse.gmf.examples.gonto.modelOntology.Ontology) domainElement)) {
			return org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.OntologyEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
				.getModelID(containerView);
		if (!org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.OntologyEditPart.MODEL_ID
				.equals(containerModelID)) {
			return -1;
		}
		int containerVisualID;
		if (org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.OntologyEditPart.MODEL_ID
				.equals(containerModelID)) {
			containerVisualID = org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.OntologyEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.OntologyEditPart.VISUAL_ID:
			if (org.eclipse.gmf.examples.gonto.modelOntology.ModelOntologyPackage.eINSTANCE
					.getAnnonymousIndividual().isSuperTypeOf(
							domainElement.eClass())) {
				return org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.AnnonymousIndividualEditPart.VISUAL_ID;
			}
			if (org.eclipse.gmf.examples.gonto.modelOntology.ModelOntologyPackage.eINSTANCE
					.getClass_().isSuperTypeOf(domainElement.eClass())) {
				return org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ClassEditPart.VISUAL_ID;
			}
			if (org.eclipse.gmf.examples.gonto.modelOntology.ModelOntologyPackage.eINSTANCE
					.getConnection().isSuperTypeOf(domainElement.eClass())) {
				return org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionEditPart.VISUAL_ID;
			}
			if (org.eclipse.gmf.examples.gonto.modelOntology.ModelOntologyPackage.eINSTANCE
					.getObjectProperty().isSuperTypeOf(domainElement.eClass())) {
				return org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ObjectPropertyEditPart.VISUAL_ID;
			}
			if (org.eclipse.gmf.examples.gonto.modelOntology.ModelOntologyPackage.eINSTANCE
					.getAnnotation().isSuperTypeOf(domainElement.eClass())) {
				return org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.AnnotationEditPart.VISUAL_ID;
			}
			if (org.eclipse.gmf.examples.gonto.modelOntology.ModelOntologyPackage.eINSTANCE
					.getNamedIndividual().isSuperTypeOf(domainElement.eClass())) {
				return org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.NamedIndividualEditPart.VISUAL_ID;
			}
			if (org.eclipse.gmf.examples.gonto.modelOntology.ModelOntologyPackage.eINSTANCE
					.getInversObjectProperty().isSuperTypeOf(
							domainElement.eClass())) {
				return org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.InversObjectPropertyEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
				.getModelID(containerView);
		if (!org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.OntologyEditPart.MODEL_ID
				.equals(containerModelID)) {
			return false;
		}
		int containerVisualID;
		if (org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.OntologyEditPart.MODEL_ID
				.equals(containerModelID)) {
			containerVisualID = org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.OntologyEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.OntologyEditPart.VISUAL_ID:
			if (org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.AnnonymousIndividualEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ClassEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ObjectPropertyEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.AnnotationEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.NamedIndividualEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.InversObjectPropertyEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.AnnonymousIndividualEditPart.VISUAL_ID:
			if (org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.AnnonymousIndividualNodeIDEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ClassEditPart.VISUAL_ID:
			if (org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.WrappingLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionEditPart.VISUAL_ID:
			if (org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ObjectPropertyEditPart.VISUAL_ID:
			if (org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ObjectPropertyNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.NamedIndividualEditPart.VISUAL_ID:
			if (org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.NamedIndividualNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(
			org.eclipse.gmf.examples.gonto.modelOntology.Ontology element) {
		return true;
	}

	/**
	 * @generated
	 */
	public static boolean checkNodeVisualID(View containerView,
			EObject domainElement, int candidate) {
		if (candidate == -1) {
			//unrecognized id is always bad
			return false;
		}
		int basic = getNodeVisualID(containerView, domainElement);
		return basic == candidate;
	}

	/**
	 * @generated
	 */
	public static boolean isCompartmentVisualID(int visualID) {
		return false;
	}

	/**
	 * @generated
	 */
	public static boolean isSemanticLeafVisualID(int visualID) {
		switch (visualID) {
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.OntologyEditPart.VISUAL_ID:
			return false;
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.AnnonymousIndividualEditPart.VISUAL_ID:
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ClassEditPart.VISUAL_ID:
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionEditPart.VISUAL_ID:
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ObjectPropertyEditPart.VISUAL_ID:
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.AnnotationEditPart.VISUAL_ID:
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.NamedIndividualEditPart.VISUAL_ID:
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.InversObjectPropertyEditPart.VISUAL_ID:
			return true;
		default:
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static final DiagramStructure TYPED_INSTANCE = new DiagramStructure() {
		/**
		 * @generated
		 */
		@Override
		public int getVisualID(View view) {
			return org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
					.getVisualID(view);
		}

		/**
		 * @generated
		 */
		@Override
		public String getModelID(View view) {
			return org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
					.getModelID(view);
		}

		/**
		 * @generated
		 */
		@Override
		public int getNodeVisualID(View containerView, EObject domainElement) {
			return org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
					.getNodeVisualID(containerView, domainElement);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean checkNodeVisualID(View containerView,
				EObject domainElement, int candidate) {
			return org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
					.checkNodeVisualID(containerView, domainElement, candidate);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean isCompartmentVisualID(int visualID) {
			return org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
					.isCompartmentVisualID(visualID);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean isSemanticLeafVisualID(int visualID) {
			return org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyVisualIDRegistry
					.isSemanticLeafVisualID(visualID);
		}
	};

}
