package org.eclipse.gmf.examples.gonto.modelOntology.diagram.providers;

import java.util.HashSet;
import java.util.IdentityHashMap;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;

/**
 * @generated
 */
public class ModelOntologyElementTypes {

	/**
	 * @generated
	 */
	private ModelOntologyElementTypes() {
	}

	/**
	 * @generated
	 */
	private static Map<IElementType, ENamedElement> elements;

	/**
	 * @generated
	 */
	private static ImageRegistry imageRegistry;

	/**
	 * @generated
	 */
	private static Set<IElementType> KNOWN_ELEMENT_TYPES;

	/**
	 * @generated
	 */
	public static final IElementType Ontology_1000 = getElementType("cs.vsb.fei.gonto.diagram.Ontology_1000"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType AnnonymousIndividual_2001 = getElementType("cs.vsb.fei.gonto.diagram.AnnonymousIndividual_2001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Class_2002 = getElementType("cs.vsb.fei.gonto.diagram.Class_2002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Connection_2003 = getElementType("cs.vsb.fei.gonto.diagram.Connection_2003"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType ObjectProperty_2004 = getElementType("cs.vsb.fei.gonto.diagram.ObjectProperty_2004"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Annotation_2005 = getElementType("cs.vsb.fei.gonto.diagram.Annotation_2005"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType NamedIndividual_2006 = getElementType("cs.vsb.fei.gonto.diagram.NamedIndividual_2006"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType InversObjectProperty_2007 = getElementType("cs.vsb.fei.gonto.diagram.InversObjectProperty_2007"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType ConnectionSource_4001 = getElementType("cs.vsb.fei.gonto.diagram.ConnectionSource_4001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType ConnectionTarget_4002 = getElementType("cs.vsb.fei.gonto.diagram.ConnectionTarget_4002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType InversObjectPropertyObjectProperty_4003 = getElementType("cs.vsb.fei.gonto.diagram.InversObjectPropertyObjectProperty_4003"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	private static ImageRegistry getImageRegistry() {
		if (imageRegistry == null) {
			imageRegistry = new ImageRegistry();
		}
		return imageRegistry;
	}

	/**
	 * @generated
	 */
	private static String getImageRegistryKey(ENamedElement element) {
		return element.getName();
	}

	/**
	 * @generated
	 */
	private static ImageDescriptor getProvidedImageDescriptor(
			ENamedElement element) {
		if (element instanceof EStructuralFeature) {
			EStructuralFeature feature = ((EStructuralFeature) element);
			EClass eContainingClass = feature.getEContainingClass();
			EClassifier eType = feature.getEType();
			if (eContainingClass != null && !eContainingClass.isAbstract()) {
				element = eContainingClass;
			} else if (eType instanceof EClass
					&& !((EClass) eType).isAbstract()) {
				element = eType;
			}
		}
		if (element instanceof EClass) {
			EClass eClass = (EClass) element;
			if (!eClass.isAbstract()) {
				return org.eclipse.gmf.examples.gonto.modelOntology.diagram.part.ModelOntologyDiagramEditorPlugin
						.getInstance().getItemImageDescriptor(
								eClass.getEPackage().getEFactoryInstance()
										.create(eClass));
			}
		}
		// TODO : support structural features
		return null;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(ENamedElement element) {
		String key = getImageRegistryKey(element);
		ImageDescriptor imageDescriptor = getImageRegistry().getDescriptor(key);
		if (imageDescriptor == null) {
			imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
		}
		return imageDescriptor;
	}

	/**
	 * @generated
	 */
	public static Image getImage(ENamedElement element) {
		String key = getImageRegistryKey(element);
		Image image = getImageRegistry().get(key);
		if (image == null) {
			ImageDescriptor imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
			image = getImageRegistry().get(key);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImageDescriptor(element);
	}

	/**
	 * @generated
	 */
	public static Image getImage(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImage(element);
	}

	/**
	 * Returns 'type' of the ecore object associated with the hint.
	 * 
	 * @generated
	 */
	public static ENamedElement getElement(IAdaptable hint) {
		Object type = hint.getAdapter(IElementType.class);
		if (elements == null) {
			elements = new IdentityHashMap<IElementType, ENamedElement>();

			elements.put(
					Ontology_1000,
					org.eclipse.gmf.examples.gonto.modelOntology.ModelOntologyPackage.eINSTANCE
							.getOntology());

			elements.put(
					AnnonymousIndividual_2001,
					org.eclipse.gmf.examples.gonto.modelOntology.ModelOntologyPackage.eINSTANCE
							.getAnnonymousIndividual());

			elements.put(
					Class_2002,
					org.eclipse.gmf.examples.gonto.modelOntology.ModelOntologyPackage.eINSTANCE
							.getClass_());

			elements.put(
					Connection_2003,
					org.eclipse.gmf.examples.gonto.modelOntology.ModelOntologyPackage.eINSTANCE
							.getConnection());

			elements.put(
					ObjectProperty_2004,
					org.eclipse.gmf.examples.gonto.modelOntology.ModelOntologyPackage.eINSTANCE
							.getObjectProperty());

			elements.put(
					Annotation_2005,
					org.eclipse.gmf.examples.gonto.modelOntology.ModelOntologyPackage.eINSTANCE
							.getAnnotation());

			elements.put(
					NamedIndividual_2006,
					org.eclipse.gmf.examples.gonto.modelOntology.ModelOntologyPackage.eINSTANCE
							.getNamedIndividual());

			elements.put(
					InversObjectProperty_2007,
					org.eclipse.gmf.examples.gonto.modelOntology.ModelOntologyPackage.eINSTANCE
							.getInversObjectProperty());

			elements.put(
					ConnectionSource_4001,
					org.eclipse.gmf.examples.gonto.modelOntology.ModelOntologyPackage.eINSTANCE
							.getConnection_Source());

			elements.put(
					ConnectionTarget_4002,
					org.eclipse.gmf.examples.gonto.modelOntology.ModelOntologyPackage.eINSTANCE
							.getConnection_Target());

			elements.put(
					InversObjectPropertyObjectProperty_4003,
					org.eclipse.gmf.examples.gonto.modelOntology.ModelOntologyPackage.eINSTANCE
							.getInversObjectProperty_ObjectProperty());
		}
		return (ENamedElement) elements.get(type);
	}

	/**
	 * @generated
	 */
	private static IElementType getElementType(String id) {
		return ElementTypeRegistry.getInstance().getType(id);
	}

	/**
	 * @generated
	 */
	public static boolean isKnownElementType(IElementType elementType) {
		if (KNOWN_ELEMENT_TYPES == null) {
			KNOWN_ELEMENT_TYPES = new HashSet<IElementType>();
			KNOWN_ELEMENT_TYPES.add(Ontology_1000);
			KNOWN_ELEMENT_TYPES.add(AnnonymousIndividual_2001);
			KNOWN_ELEMENT_TYPES.add(Class_2002);
			KNOWN_ELEMENT_TYPES.add(Connection_2003);
			KNOWN_ELEMENT_TYPES.add(ObjectProperty_2004);
			KNOWN_ELEMENT_TYPES.add(Annotation_2005);
			KNOWN_ELEMENT_TYPES.add(NamedIndividual_2006);
			KNOWN_ELEMENT_TYPES.add(InversObjectProperty_2007);
			KNOWN_ELEMENT_TYPES.add(ConnectionSource_4001);
			KNOWN_ELEMENT_TYPES.add(ConnectionTarget_4002);
			KNOWN_ELEMENT_TYPES.add(InversObjectPropertyObjectProperty_4003);
		}
		return KNOWN_ELEMENT_TYPES.contains(elementType);
	}

	/**
	 * @generated
	 */
	public static IElementType getElementType(int visualID) {
		switch (visualID) {
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.OntologyEditPart.VISUAL_ID:
			return Ontology_1000;
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.AnnonymousIndividualEditPart.VISUAL_ID:
			return AnnonymousIndividual_2001;
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ClassEditPart.VISUAL_ID:
			return Class_2002;
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionEditPart.VISUAL_ID:
			return Connection_2003;
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ObjectPropertyEditPart.VISUAL_ID:
			return ObjectProperty_2004;
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.AnnotationEditPart.VISUAL_ID:
			return Annotation_2005;
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.NamedIndividualEditPart.VISUAL_ID:
			return NamedIndividual_2006;
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.InversObjectPropertyEditPart.VISUAL_ID:
			return InversObjectProperty_2007;
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionSourceEditPart.VISUAL_ID:
			return ConnectionSource_4001;
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.ConnectionTargetEditPart.VISUAL_ID:
			return ConnectionTarget_4002;
		case org.eclipse.gmf.examples.gonto.modelOntology.diagram.edit.parts.InversObjectPropertyObjectPropertyEditPart.VISUAL_ID:
			return InversObjectPropertyObjectProperty_4003;
		}
		return null;
	}

}
