/**
 */
package org.eclipse.gmf.examples.gonto.modelOntology;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.eclipse.gmf.examples.gonto.modelOntology.ModelOntologyFactory
 * @model kind="package"
 * @generated
 */
public interface ModelOntologyPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "modelOntology";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://modelOntology/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "modelOntology";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	ModelOntologyPackage eINSTANCE = org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.impl.OntologyImpl <em>Ontology</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.OntologyImpl
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getOntology()
	 * @generated
	 */
	int ONTOLOGY = 0;

	/**
	 * The feature id for the '<em><b>Ontology IRI</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONTOLOGY__ONTOLOGY_IRI = 0;

	/**
	 * The feature id for the '<em><b>Graphical Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONTOLOGY__GRAPHICAL_ELEMENT = 1;

	/**
	 * The number of structural features of the '<em>Ontology</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONTOLOGY_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.impl.GraphicalObjectImpl <em>Graphical Object</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.GraphicalObjectImpl
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getGraphicalObject()
	 * @generated
	 */
	int GRAPHICAL_OBJECT = 10;

	/**
	 * The number of structural features of the '<em>Graphical Object</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GRAPHICAL_OBJECT_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.impl.AxiomImpl <em>Axiom</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.AxiomImpl
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getAxiom()
	 * @generated
	 */
	int AXIOM = 1;

	/**
	 * The feature id for the '<em><b>Axiom</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AXIOM__AXIOM = GRAPHICAL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Axiom</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AXIOM_FEATURE_COUNT = GRAPHICAL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.Entity <em>Entity</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.Entity
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getEntity()
	 * @generated
	 */
	int ENTITY = 2;

	/**
	 * The feature id for the '<em><b>Entity IRI</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__ENTITY_IRI = 0;

	/**
	 * The number of structural features of the '<em>Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.impl.ClassImpl <em>Class</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ClassImpl
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getClass_()
	 * @generated
	 */
	int CLASS = 3;

	/**
	 * The feature id for the '<em><b>Entity IRI</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASS__ENTITY_IRI = ENTITY__ENTITY_IRI;

	/**
	 * The number of structural features of the '<em>Class</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASS_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.Individual <em>Individual</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.Individual
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getIndividual()
	 * @generated
	 */
	int INDIVIDUAL = 4;

	/**
	 * The number of structural features of the '<em>Individual</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDIVIDUAL_FEATURE_COUNT = GRAPHICAL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.impl.NamedIndividualImpl <em>Named Individual</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.NamedIndividualImpl
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getNamedIndividual()
	 * @generated
	 */
	int NAMED_INDIVIDUAL = 5;

	/**
	 * The feature id for the '<em><b>Entity IRI</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_INDIVIDUAL__ENTITY_IRI = INDIVIDUAL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_INDIVIDUAL__NAME = INDIVIDUAL_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Named Individual</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_INDIVIDUAL_FEATURE_COUNT = INDIVIDUAL_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.impl.AnnonymousIndividualImpl <em>Annonymous Individual</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.AnnonymousIndividualImpl
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getAnnonymousIndividual()
	 * @generated
	 */
	int ANNONYMOUS_INDIVIDUAL = 6;

	/**
	 * The feature id for the '<em><b>Node ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANNONYMOUS_INDIVIDUAL__NODE_ID = INDIVIDUAL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Alias</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANNONYMOUS_INDIVIDUAL__ALIAS = INDIVIDUAL_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Annonymous Individual</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANNONYMOUS_INDIVIDUAL_FEATURE_COUNT = INDIVIDUAL_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.impl.ObjectPropertyImpl <em>Object Property</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ObjectPropertyImpl
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getObjectProperty()
	 * @generated
	 */
	int OBJECT_PROPERTY = 7;

	/**
	 * The feature id for the '<em><b>Entity IRI</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBJECT_PROPERTY__ENTITY_IRI = ENTITY__ENTITY_IRI;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBJECT_PROPERTY__NAME = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Object Property</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBJECT_PROPERTY_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.ObjectPropertyExpression <em>Object Property Expression</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.ObjectPropertyExpression
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getObjectPropertyExpression()
	 * @generated
	 */
	int OBJECT_PROPERTY_EXPRESSION = 8;

	/**
	 * The number of structural features of the '<em>Object Property Expression</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBJECT_PROPERTY_EXPRESSION_FEATURE_COUNT = GRAPHICAL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.impl.InversObjectPropertyImpl <em>Invers Object Property</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.InversObjectPropertyImpl
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getInversObjectProperty()
	 * @generated
	 */
	int INVERS_OBJECT_PROPERTY = 9;

	/**
	 * The feature id for the '<em><b>Object Property</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVERS_OBJECT_PROPERTY__OBJECT_PROPERTY = OBJECT_PROPERTY_EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Invers Object Property</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVERS_OBJECT_PROPERTY_FEATURE_COUNT = OBJECT_PROPERTY_EXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.impl.ConnectionImpl <em>Connection</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ConnectionImpl
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getConnection()
	 * @generated
	 */
	int CONNECTION = 11;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__NAME = GRAPHICAL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__SOURCE = GRAPHICAL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__TARGET = GRAPHICAL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Connection</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION_FEATURE_COUNT = GRAPHICAL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.impl.AnnotationImpl <em>Annotation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.AnnotationImpl
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getAnnotation()
	 * @generated
	 */
	int ANNOTATION = 12;

	/**
	 * The number of structural features of the '<em>Annotation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANNOTATION_FEATURE_COUNT = GRAPHICAL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '<em>IRI</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see java.lang.Object
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getIRI()
	 * @generated
	 */
	int IRI = 13;


	/**
	 * Returns the meta object for class '{@link org.eclipse.gmf.examples.gonto.modelOntology.Ontology <em>Ontology</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Ontology</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.Ontology
	 * @generated
	 */
	EClass getOntology();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.gmf.examples.gonto.modelOntology.Ontology#getOntologyIRI <em>Ontology IRI</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ontology IRI</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.Ontology#getOntologyIRI()
	 * @see #getOntology()
	 * @generated
	 */
	EAttribute getOntology_OntologyIRI();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.gmf.examples.gonto.modelOntology.Ontology#getGraphicalElement <em>Graphical Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Graphical Element</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.Ontology#getGraphicalElement()
	 * @see #getOntology()
	 * @generated
	 */
	EReference getOntology_GraphicalElement();

	/**
	 * Returns the meta object for class '{@link org.eclipse.gmf.examples.gonto.modelOntology.Axiom <em>Axiom</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Axiom</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.Axiom
	 * @generated
	 */
	EClass getAxiom();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.gmf.examples.gonto.modelOntology.Axiom#getAxiom <em>Axiom</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Axiom</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.Axiom#getAxiom()
	 * @see #getAxiom()
	 * @generated
	 */
	EReference getAxiom_Axiom();

	/**
	 * Returns the meta object for class '{@link org.eclipse.gmf.examples.gonto.modelOntology.Entity <em>Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Entity</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.Entity
	 * @generated
	 */
	EClass getEntity();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.gmf.examples.gonto.modelOntology.Entity#getEntityIRI <em>Entity IRI</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Entity IRI</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.Entity#getEntityIRI()
	 * @see #getEntity()
	 * @generated
	 */
	EAttribute getEntity_EntityIRI();

	/**
	 * Returns the meta object for class '{@link org.eclipse.gmf.examples.gonto.modelOntology.Class <em>Class</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Class</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.Class
	 * @generated
	 */
	EClass getClass_();

	/**
	 * Returns the meta object for class '{@link org.eclipse.gmf.examples.gonto.modelOntology.Individual <em>Individual</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Individual</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.Individual
	 * @generated
	 */
	EClass getIndividual();

	/**
	 * Returns the meta object for class '{@link org.eclipse.gmf.examples.gonto.modelOntology.NamedIndividual <em>Named Individual</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Named Individual</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.NamedIndividual
	 * @generated
	 */
	EClass getNamedIndividual();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.gmf.examples.gonto.modelOntology.NamedIndividual#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.NamedIndividual#getName()
	 * @see #getNamedIndividual()
	 * @generated
	 */
	EAttribute getNamedIndividual_Name();

	/**
	 * Returns the meta object for class '{@link org.eclipse.gmf.examples.gonto.modelOntology.AnnonymousIndividual <em>Annonymous Individual</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Annonymous Individual</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.AnnonymousIndividual
	 * @generated
	 */
	EClass getAnnonymousIndividual();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.gmf.examples.gonto.modelOntology.AnnonymousIndividual#getNodeID <em>Node ID</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Node ID</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.AnnonymousIndividual#getNodeID()
	 * @see #getAnnonymousIndividual()
	 * @generated
	 */
	EAttribute getAnnonymousIndividual_NodeID();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.gmf.examples.gonto.modelOntology.AnnonymousIndividual#getAlias <em>Alias</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Alias</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.AnnonymousIndividual#getAlias()
	 * @see #getAnnonymousIndividual()
	 * @generated
	 */
	EAttribute getAnnonymousIndividual_Alias();

	/**
	 * Returns the meta object for class '{@link org.eclipse.gmf.examples.gonto.modelOntology.ObjectProperty <em>Object Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Object Property</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.ObjectProperty
	 * @generated
	 */
	EClass getObjectProperty();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.gmf.examples.gonto.modelOntology.ObjectProperty#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.ObjectProperty#getName()
	 * @see #getObjectProperty()
	 * @generated
	 */
	EAttribute getObjectProperty_Name();

	/**
	 * Returns the meta object for class '{@link org.eclipse.gmf.examples.gonto.modelOntology.ObjectPropertyExpression <em>Object Property Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Object Property Expression</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.ObjectPropertyExpression
	 * @generated
	 */
	EClass getObjectPropertyExpression();

	/**
	 * Returns the meta object for class '{@link org.eclipse.gmf.examples.gonto.modelOntology.InversObjectProperty <em>Invers Object Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Invers Object Property</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.InversObjectProperty
	 * @generated
	 */
	EClass getInversObjectProperty();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.gmf.examples.gonto.modelOntology.InversObjectProperty#getObjectProperty <em>Object Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Object Property</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.InversObjectProperty#getObjectProperty()
	 * @see #getInversObjectProperty()
	 * @generated
	 */
	EReference getInversObjectProperty_ObjectProperty();

	/**
	 * Returns the meta object for class '{@link org.eclipse.gmf.examples.gonto.modelOntology.GraphicalObject <em>Graphical Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Graphical Object</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.GraphicalObject
	 * @generated
	 */
	EClass getGraphicalObject();

	/**
	 * Returns the meta object for class '{@link org.eclipse.gmf.examples.gonto.modelOntology.Connection <em>Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Connection</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.Connection
	 * @generated
	 */
	EClass getConnection();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.gmf.examples.gonto.modelOntology.Connection#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.Connection#getName()
	 * @see #getConnection()
	 * @generated
	 */
	EAttribute getConnection_Name();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.gmf.examples.gonto.modelOntology.Connection#getSource <em>Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Source</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.Connection#getSource()
	 * @see #getConnection()
	 * @generated
	 */
	EReference getConnection_Source();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.gmf.examples.gonto.modelOntology.Connection#getTarget <em>Target</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Target</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.Connection#getTarget()
	 * @see #getConnection()
	 * @generated
	 */
	EReference getConnection_Target();

	/**
	 * Returns the meta object for class '{@link org.eclipse.gmf.examples.gonto.modelOntology.Annotation <em>Annotation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Annotation</em>'.
	 * @see org.eclipse.gmf.examples.gonto.modelOntology.Annotation
	 * @generated
	 */
	EClass getAnnotation();

	/**
	 * Returns the meta object for data type '{@link java.lang.Object <em>IRI</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>IRI</em>'.
	 * @see java.lang.Object
	 * @model instanceClass="java.lang.Object"
	 * @generated
	 */
	EDataType getIRI();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	ModelOntologyFactory getModelOntologyFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.impl.OntologyImpl <em>Ontology</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.OntologyImpl
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getOntology()
		 * @generated
		 */
		EClass ONTOLOGY = eINSTANCE.getOntology();

		/**
		 * The meta object literal for the '<em><b>Ontology IRI</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ONTOLOGY__ONTOLOGY_IRI = eINSTANCE.getOntology_OntologyIRI();

		/**
		 * The meta object literal for the '<em><b>Graphical Element</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ONTOLOGY__GRAPHICAL_ELEMENT = eINSTANCE.getOntology_GraphicalElement();

		/**
		 * The meta object literal for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.impl.AxiomImpl <em>Axiom</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.AxiomImpl
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getAxiom()
		 * @generated
		 */
		EClass AXIOM = eINSTANCE.getAxiom();

		/**
		 * The meta object literal for the '<em><b>Axiom</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference AXIOM__AXIOM = eINSTANCE.getAxiom_Axiom();

		/**
		 * The meta object literal for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.Entity <em>Entity</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.Entity
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getEntity()
		 * @generated
		 */
		EClass ENTITY = eINSTANCE.getEntity();

		/**
		 * The meta object literal for the '<em><b>Entity IRI</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENTITY__ENTITY_IRI = eINSTANCE.getEntity_EntityIRI();

		/**
		 * The meta object literal for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.impl.ClassImpl <em>Class</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ClassImpl
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getClass_()
		 * @generated
		 */
		EClass CLASS = eINSTANCE.getClass_();

		/**
		 * The meta object literal for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.Individual <em>Individual</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.Individual
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getIndividual()
		 * @generated
		 */
		EClass INDIVIDUAL = eINSTANCE.getIndividual();

		/**
		 * The meta object literal for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.impl.NamedIndividualImpl <em>Named Individual</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.NamedIndividualImpl
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getNamedIndividual()
		 * @generated
		 */
		EClass NAMED_INDIVIDUAL = eINSTANCE.getNamedIndividual();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NAMED_INDIVIDUAL__NAME = eINSTANCE.getNamedIndividual_Name();

		/**
		 * The meta object literal for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.impl.AnnonymousIndividualImpl <em>Annonymous Individual</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.AnnonymousIndividualImpl
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getAnnonymousIndividual()
		 * @generated
		 */
		EClass ANNONYMOUS_INDIVIDUAL = eINSTANCE.getAnnonymousIndividual();

		/**
		 * The meta object literal for the '<em><b>Node ID</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ANNONYMOUS_INDIVIDUAL__NODE_ID = eINSTANCE.getAnnonymousIndividual_NodeID();

		/**
		 * The meta object literal for the '<em><b>Alias</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ANNONYMOUS_INDIVIDUAL__ALIAS = eINSTANCE.getAnnonymousIndividual_Alias();

		/**
		 * The meta object literal for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.impl.ObjectPropertyImpl <em>Object Property</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ObjectPropertyImpl
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getObjectProperty()
		 * @generated
		 */
		EClass OBJECT_PROPERTY = eINSTANCE.getObjectProperty();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OBJECT_PROPERTY__NAME = eINSTANCE.getObjectProperty_Name();

		/**
		 * The meta object literal for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.ObjectPropertyExpression <em>Object Property Expression</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.ObjectPropertyExpression
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getObjectPropertyExpression()
		 * @generated
		 */
		EClass OBJECT_PROPERTY_EXPRESSION = eINSTANCE.getObjectPropertyExpression();

		/**
		 * The meta object literal for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.impl.InversObjectPropertyImpl <em>Invers Object Property</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.InversObjectPropertyImpl
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getInversObjectProperty()
		 * @generated
		 */
		EClass INVERS_OBJECT_PROPERTY = eINSTANCE.getInversObjectProperty();

		/**
		 * The meta object literal for the '<em><b>Object Property</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INVERS_OBJECT_PROPERTY__OBJECT_PROPERTY = eINSTANCE.getInversObjectProperty_ObjectProperty();

		/**
		 * The meta object literal for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.impl.GraphicalObjectImpl <em>Graphical Object</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.GraphicalObjectImpl
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getGraphicalObject()
		 * @generated
		 */
		EClass GRAPHICAL_OBJECT = eINSTANCE.getGraphicalObject();

		/**
		 * The meta object literal for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.impl.ConnectionImpl <em>Connection</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ConnectionImpl
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getConnection()
		 * @generated
		 */
		EClass CONNECTION = eINSTANCE.getConnection();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CONNECTION__NAME = eINSTANCE.getConnection_Name();

		/**
		 * The meta object literal for the '<em><b>Source</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONNECTION__SOURCE = eINSTANCE.getConnection_Source();

		/**
		 * The meta object literal for the '<em><b>Target</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONNECTION__TARGET = eINSTANCE.getConnection_Target();

		/**
		 * The meta object literal for the '{@link org.eclipse.gmf.examples.gonto.modelOntology.impl.AnnotationImpl <em>Annotation</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.AnnotationImpl
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getAnnotation()
		 * @generated
		 */
		EClass ANNOTATION = eINSTANCE.getAnnotation();

		/**
		 * The meta object literal for the '<em>IRI</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see java.lang.Object
		 * @see org.eclipse.gmf.examples.gonto.modelOntology.impl.ModelOntologyPackageImpl#getIRI()
		 * @generated
		 */
		EDataType IRI = eINSTANCE.getIRI();

	}

} //ModelOntologyPackage
