/**
 */
package org.eclipse.gmf.examples.gonto.modelOntology.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.eclipse.gmf.examples.gonto.modelOntology.AnnonymousIndividual;
import org.eclipse.gmf.examples.gonto.modelOntology.Annotation;
import org.eclipse.gmf.examples.gonto.modelOntology.Connection;
import org.eclipse.gmf.examples.gonto.modelOntology.GraphicalObject;
import org.eclipse.gmf.examples.gonto.modelOntology.InversObjectProperty;
import org.eclipse.gmf.examples.gonto.modelOntology.ModelOntologyFactory;
import org.eclipse.gmf.examples.gonto.modelOntology.ModelOntologyPackage;
import org.eclipse.gmf.examples.gonto.modelOntology.NamedIndividual;
import org.eclipse.gmf.examples.gonto.modelOntology.ObjectProperty;
import org.eclipse.gmf.examples.gonto.modelOntology.Ontology;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class ModelOntologyFactoryImpl extends EFactoryImpl implements ModelOntologyFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static ModelOntologyFactory init() {
		try {
			ModelOntologyFactory theModelOntologyFactory = (ModelOntologyFactory)EPackage.Registry.INSTANCE.getEFactory("http://modelOntology/1.0"); 
			if (theModelOntologyFactory != null) {
				return theModelOntologyFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new ModelOntologyFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ModelOntologyFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case ModelOntologyPackage.ONTOLOGY: return createOntology();
			case ModelOntologyPackage.CLASS: return createClass();
			case ModelOntologyPackage.NAMED_INDIVIDUAL: return createNamedIndividual();
			case ModelOntologyPackage.ANNONYMOUS_INDIVIDUAL: return createAnnonymousIndividual();
			case ModelOntologyPackage.OBJECT_PROPERTY: return createObjectProperty();
			case ModelOntologyPackage.INVERS_OBJECT_PROPERTY: return createInversObjectProperty();
			case ModelOntologyPackage.GRAPHICAL_OBJECT: return createGraphicalObject();
			case ModelOntologyPackage.CONNECTION: return createConnection();
			case ModelOntologyPackage.ANNOTATION: return createAnnotation();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case ModelOntologyPackage.IRI:
				return createIRIFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case ModelOntologyPackage.IRI:
				return convertIRIToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Ontology createOntology() {
		OntologyImpl ontology = new OntologyImpl();
		return ontology;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public org.eclipse.gmf.examples.gonto.modelOntology.Class createClass() {
		ClassImpl class_ = new ClassImpl();
		return class_;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NamedIndividual createNamedIndividual() {
		NamedIndividualImpl namedIndividual = new NamedIndividualImpl();
		return namedIndividual;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AnnonymousIndividual createAnnonymousIndividual() {
		AnnonymousIndividualImpl annonymousIndividual = new AnnonymousIndividualImpl();
		return annonymousIndividual;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ObjectProperty createObjectProperty() {
		ObjectPropertyImpl objectProperty = new ObjectPropertyImpl();
		return objectProperty;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InversObjectProperty createInversObjectProperty() {
		InversObjectPropertyImpl inversObjectProperty = new InversObjectPropertyImpl();
		return inversObjectProperty;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GraphicalObject createGraphicalObject() {
		GraphicalObjectImpl graphicalObject = new GraphicalObjectImpl();
		return graphicalObject;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Connection createConnection() {
		ConnectionImpl connection = new ConnectionImpl();
		return connection;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Annotation createAnnotation() {
		AnnotationImpl annotation = new AnnotationImpl();
		return annotation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object createIRIFromString(EDataType eDataType, String initialValue) {
		return super.createFromString(eDataType, initialValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertIRIToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ModelOntologyPackage getModelOntologyPackage() {
		return (ModelOntologyPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static ModelOntologyPackage getPackage() {
		return ModelOntologyPackage.eINSTANCE;
	}

} //ModelOntologyFactoryImpl
